import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.awt.*;
import javax.swing.filechooser.FileFilter;
import java.io.*;
import javax.media.jai.JAI;
import javax.media.jai.PlanarImage;
import java.util.*;
import java.awt.image.*;
import java.awt.image.renderable.*;
import javax.media.jai.*;
import javax.media.jai.operator.*;

public class BrightContrastDlg extends JInternalFrame implements ChangeListener {
    private JSlider m_slBrightness;
    private JSlider m_slContrastLow;
    private JSlider m_slContrastHigh;
    private PicEdit m_frmParent;
    private int m_nContrastLow, m_nContrastHigh;

    public BrightContrastDlg(final PicEdit frmParent) {
        super("Helligkeit/ Kontrast...", false, true, false, true);
        this.m_frmParent = frmParent;
        getContentPane().setLayout(new GridLayout(7, 1, 0, 0));
        Point parentLoc = frmParent.getLocation();
        setLocation(parentLoc.x + 100, parentLoc.y + 100);

        m_slBrightness = new JSlider(JSlider.HORIZONTAL, -255, 255, 0);
        Hashtable labels = new Hashtable();
        labels.put(new Integer(-255), new JLabel("-255"));
        labels.put(new Integer(0), new JLabel("0"));
        labels.put(new Integer(255), new JLabel("255"));
        m_slBrightness.setLabelTable(labels);
        m_slBrightness.setPaintLabels(true);
        m_slBrightness.addChangeListener(this);

        m_slContrastLow = new JSlider(JSlider.HORIZONTAL, -255, 255, 0);
        labels = new Hashtable();
        labels.put(new Integer(-255), new JLabel("-255"));
        labels.put(new Integer(0), new JLabel("0"));
        labels.put(new Integer(255), new JLabel("255"));
        m_slContrastLow.setLabelTable(labels);
        m_slContrastLow.setPaintLabels(true);
        m_slContrastLow.addChangeListener(this);

        m_slContrastHigh = new JSlider(JSlider.HORIZONTAL, -255, 255, 0);
        labels.put(new Integer(-255), new JLabel("-255"));
        labels.put(new Integer(0), new JLabel("0"));
        labels.put(new Integer(255), new JLabel("255"));
        m_slContrastHigh.setLabelTable(labels);
        m_slContrastHigh.setPaintLabels(true);
        m_slContrastHigh.addChangeListener(this);

        JPanel panelButtons = new JPanel();
        JButton btnDo = new JButton("Anwenden");
        JButton btnUnDo = new JButton("Verwerfen");
        panelButtons.add(btnDo);
        panelButtons.add(btnUnDo);

        // Eventhandlers...
        btnDo.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                frmParent.setImage();
            }
        });
        btnUnDo.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                frmParent.rollBack();
            }
        });

        //Put everything together
        getContentPane().add(new JLabel("Kontrast nieder:"));
        getContentPane().add(m_slContrastLow);
        getContentPane().add(new JLabel("Kontrast hoch:"));
        getContentPane().add(m_slContrastHigh);
        getContentPane().add(new JLabel("Helligkeit:"));
        getContentPane().add(m_slBrightness);
        getContentPane().add(panelButtons);
        pack();
        frmParent.addChild(this);
    }

    public void stateChanged(ChangeEvent e) {
        JSlider slSource = (JSlider) e.getSource();
        int nBrightness = m_slBrightness.getValue();
        m_nContrastLow = m_slContrastLow.getValue();
        m_nContrastHigh = m_slContrastHigh.getValue();

        if (slSource == m_slContrastLow || slSource == m_slContrastHigh) {
            m_frmParent.setContrast(m_nContrastLow, m_nContrastHigh);
        }
        else if (slSource == m_slBrightness) {
            m_frmParent.setBrightness(nBrightness);
        }
    }
}